算法日常・每日刷题--<贪心+大根堆>2

2208. 将数组和减半的最少操作次数 - 力扣(LeetCode)2208. 将数组和减半的最少操作次数 - 给你一个正整数数组 nums 。每一次操作中,你可以从 nums 中选择 任意 一个数并将它减小到 恰好 一半。(注意,在后续操作中你可以对减半过的数继续执行操作)请你返回将 nums 数组和 至少 减少一半的 最少 操作数。 示例 1:输入:nums = 5,19,8,1输出:3解释:初始 nums 的和为 5 + 19 + 8 + 1 = 33 。以下是将数组和减少至少一半的一种方法:选择数字 19 并减小为 9.5 。选择数字 9.5 并减小为 4.75 。选择数字 8 并减小为 4 。最终数组为 5, 4.75, 4, 1 ,和为 5 + 4.75 + 4 + 1 = 14.75 。nums 的和减小了 33 - 14.75 = 18.25 ,减小的部分超过了初始数组和的一半,18.25 >= 33/2 = 16.5 。我们需要 3 个操作实现题目要求,所以返回 3 。可以证明,无法通过少于 3 个操作使数组和减少至少一半。示例 2:输入:nums = 3,8,20输出:3解释:初始 nums 的和为 3 + 8 + 20 = 31 。以下是将数组和减少至少一半的一种方法:选择数字 20 并减小为 10 。选择数字 10 并减小为 5 。选择数字 3 并减小为 1.5 。最终数组为 1.5, 8, 5 ,和为 1.5 + 8 + 5 = 14.5 。nums 的和减小了 31 - 14.5 = 16.5 ,减小的部分超过了初始数组和的一半, 16.5 >= 31/2 = 15.5 。我们需要 3 个操作实现题目要求,所以返回 3 。可以证明,无法通过少于 3 个操作使数组和减少至少一半。 提示: * 1 <= nums.length <= 105 * 1 <= numsi <= 107https://leetcode.cn/problems/minimum-operations-to-halve-array-sum/description/

题目大意

给正整数数组,每次操作:挑一个数字,把它变成原来的一半 (可以浮点数)。 求:让数组总和至少减少一半,最少需要多少次操作。

解法

贪心思路:每一次,永远选当前最大的数字减半 。 把最大的数减半,单次带来的总和下降量最大,总操作次数最少。 数据结构:大根堆(优先队列 priority_queue),每次取出最大值。

cpp 复制代码
class Solution {
public:
    int halveArray(vector<int>& nums) {
        priority_queue<double >heap;
        double sum=0;
        for(auto e:nums)
        {
            heap.push(e);
            sum+=e;
        }
        double target=sum/2.0;
        int i=0;
        while(sum>target)
        {
            double high=heap.top()/2;heap.pop();
            heap.push(high);
            sum-=high;
            i++;
        }
        return i;


    }
};
相关推荐
闻缺陷则喜何志丹2 小时前
【C++特性】四种类型转
c++·算法·类型转换
喵本喵叁肆2 小时前
用 Boosting 把弱隐私算法炼成强隐私算法(英文原题:Boosting and Differential Privacy (FOCS 2010))
算法·集成学习·boosting
GrowingIO技术社区3 小时前
CDP、行为分析、归因与营销自动化有什么区别?
数据结构·数据挖掘·数据分析
GrowingIO技术社区3 小时前
实时标签怎样验收?从数据更新到分群可用
数据结构·数据挖掘·数据分析
青梅味猪大肠3 小时前
【操作系统-60】临近适应算法
java·linux·开发语言·嵌入式硬件·算法·操作系统
其实防守也摸鱼18 小时前
个人学习 Pwn 思路:从基础到漏洞利用的进阶路径
大数据·前端·人工智能·chrome·算法·安全·网络安全
Nuanyt18 小时前
LeetCode Hot 100 链表专题(五)· 2 题(Java)
java·算法·leetcode·链表
w_zero_one21 小时前
递归算法(一)
java·开发语言·算法